#include <cmoc.h>
#include <coco.h>

unsigned char *pia1 = 0xff00;
unsigned char *pia2 = 0xff20;

void print_menu()
{
    cls(1);
    printf("PIA 2 MIRROR TEST\n");
    printf("\n");
    printf("MIRROR: $%4x\n", pia2 );
    printf("[H]IGHER/[L]OWER\n");
    printf("\n");
    printf("[S]OUND TEST (DAC)\n");
    printf("[B]OUND TEST (1-BIT)\n");
    printf("[V]DG TEST\n");
    printf("\n");
    printf("[Q]UIT\n");
}

void snd()
{
    int j,i;

    /* Switch to internal audio */
    pia1[1] = 0xb4;
    pia1[3] = 0x35;
    
    /* Turn master switch on */
    pia2[3] = 0x3f;
    
    for(j=0; j<20; j++ )
    {
        pia2[0] = 0xff;
        for(i=0;i<200;i++);
        pia2[0] = 0;
        for(i=0;i<200;i++);
    }

    /* Turn master switch off */
    pia2[3] = 0x37;
}

void vdg()
{
    int j,i;
    
    for(j=0; j<20; j++ )
    {
        pia2[2] = 0x84;
        for(i=0;i<200;i++);
        pia2[2] = 0x04;
        for(i=0;i<200;i++);
    }
}

void bsnd()
{
    int j,i;
    
    /* Access DDR */
    pia2[3] = 0x33;
    /* Set pin PB1 to output */
    pia2[2] = 0xFF;
    /* Turn master switch off */
    pia2[3] = 0x37;

   for(j=0; j<2; j++ )
    {
        pia2[2] = 0x02;
        for(i=0;i<2000;i++);
        pia2[2] = 0x00;
        for(i=0;i<2000;i++);
    }
    
    /* Access DDR */
    pia2[3] = 0x33;
    /* Set pin PB1 to input */
    pia2[2] = 0xF8;
    /* Turn master switch off */
    pia2[3] = 0x37;
}

int main()
{
    initCoCoSupport();
    print_menu();
    byte c = 0;
    byte blink = TRUE;
    
    while (c != 'Q')
    {
        c = waitkey(blink);

        switch(c)
        {
            case 'H':
                if(pia2!=0xff3c)
                {
                    pia2 += 4;
                    print_menu();
                }
                
                break;
                
            case 'L':
                if(pia2!=0xff20)
                {
                    pia2 -= 4;
                    print_menu();
                }
                
                break;
            
            case 'S':
                printf("S");
                snd();
                print_menu();
                break;
                
            case 'B':
                printf("B");
                bsnd();
                print_menu();
                break;
                
            case 'V':
                printf("V");
                vdg();
                print_menu();
                break;
        }
    }
    
    return 0;
}
